# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class TeamMembership(pulumi.CustomResource):
    role: pulumi.Output[str]
    """
    The role of the user in the team. One of `observer`, `responder`, or `manager`. Defaults to `manager`.
    """
    team_id: pulumi.Output[str]
    """
    The ID of the team in which the user will belong.
    """
    user_id: pulumi.Output[str]
    """
    The ID of the user to add to the team.
    """
    def __init__(__self__, resource_name, opts=None, role=None, team_id=None, user_id=None, __props__=None, __name__=None, __opts__=None):
        """
        A [team membership](https://v2.developer.pagerduty.com/v2/page/api-reference#!/Teams/put_teams_id_users_user_id) manages memberships within a team.

        ## Example Usage



        ```python
        import pulumi
        import pulumi_pagerduty as pagerduty

        foo_user = pagerduty.User("fooUser", email="foo@bar.com")
        foo_team = pagerduty.Team("fooTeam", description="foo")
        foo_team_membership = pagerduty.TeamMembership("fooTeamMembership",
            role="manager",
            team_id=foo_team.id,
            user_id=foo_user.id)
        ```


        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] role: The role of the user in the team. One of `observer`, `responder`, or `manager`. Defaults to `manager`.
        :param pulumi.Input[str] team_id: The ID of the team in which the user will belong.
        :param pulumi.Input[str] user_id: The ID of the user to add to the team.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['role'] = role
            if team_id is None:
                raise TypeError("Missing required property 'team_id'")
            __props__['team_id'] = team_id
            if user_id is None:
                raise TypeError("Missing required property 'user_id'")
            __props__['user_id'] = user_id
        super(TeamMembership, __self__).__init__(
            'pagerduty:index/teamMembership:TeamMembership',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, role=None, team_id=None, user_id=None):
        """
        Get an existing TeamMembership resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] role: The role of the user in the team. One of `observer`, `responder`, or `manager`. Defaults to `manager`.
        :param pulumi.Input[str] team_id: The ID of the team in which the user will belong.
        :param pulumi.Input[str] user_id: The ID of the user to add to the team.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["role"] = role
        __props__["team_id"] = team_id
        __props__["user_id"] = user_id
        return TeamMembership(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

